routes/web.php
<?php

use App\Http\Controllers\ArticleController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\LikeController;
use App\Http\Controllers\PageController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\UserController;
use App\Models\Article;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

# Home
Route::get('/', HomeController::class)->name('home');

// # Users
Route::get('/users', [UserController::class, 'index'])->name('users.index');
Route::get('/users/{user}', [UserController::class, 'show'])->name('users.show');

# Approvement
Route::controller(ArticleController::class)->middleware('can.write.article')->group(function() {
    # Table
    Route::get('articles/table', [ArticleController::class, 'table'])->name('articles.table');
    # Update Status
    Route::put('articles/{article}/update-status', [ArticleController::class, 'updateStatus'])->name('articles.update-status');
});


# Article Search
Route::get('articles/search', [ArticleController::class, 'search'])->name('articles.search');

# Articles
Route::resource('articles', ArticleController::class);

# Category
Route::resource('categories', CategoryController::class);

# Tags
Route::resource('tags', TagController::class);


Route::middleware('auth')->group(function() {
    # Comments
    Route::controller(CommentController::class)->group(function () {
        Route::post('comments/{article}', 'store')->name('comments.store');
        Route::delete('comments/{comment}', 'destroy')->name('comments.destroy');
    });
    # Likes
    Route::controller(LikeController::class)->group(function() {
        Route::post('like-comment/{comment}', 'likeComment')->name('comments.like');
        Route::post('like-article/{article}', 'likeArticle')->name('articles.like');
    });
});


# Auth
require __DIR__ . '/auth.php';

Route::controller(RoleController::class)->middleware('only.admin')->group(function () {
    Route::post('roles/assign/{user}', 'assign')->name('roles.assign');
});

# Account
Route::controller(UserController::class)->group(function() {
    Route::get('users', 'index')->name('users.index');
    Route::get('/account/edit', 'edit')->name('users.edit');
    Route::put('/account/edit', 'update')->name('users.update');
    Route::get('/{user}', [UserController::class, 'show'])->name('users.show');
});

# Change Password
Route::controller(ChangePasswordController::class)->middleware('auth')->group(function () {
    Route::get('account/password-edit', 'edit')->name('change-password.edit');
    Route::put('account/password-edit', 'update')->name('change-password.update');
});

// # Users
Route::get('/{user}', [UserController::class, 'show'])->name('user.show');

app/Models/Article.php
<?php

namespace App\Models;

use App\Traits\HasLike;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Laravel\Scout\Searchable;

class Article extends Model
{
    use HasFactory, HasLike, Searchable;
    protected $table = 'articles';

    # fillable
    protected $fillable = ['user_id', 'category_id', 'title', 'slug', 'body', 'picture', 'published_at'];

    protected $casts = [
        'status' => \App\Enums\ArticleStatus::class,
        'published_at' => 'datetime',
    ];

    # with
    protected $with = ['user', 'category', 'tags'];

    # get route key name
    public function getRouteKeyName()
    {
        return 'slug';
    }

    # published article
    public function scopePublished($query)
    {
        return $query->where('status', \App\Enums\ArticleStatus::PUBLISHED);
    }

    # relation table
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function category()
    {
        return $this->belongsTo(Category::class);
    }

    public function tags()
    {
        return $this->belongsToMany(Tag::class);
    }

    public function comments()
    {
        return $this->morphMany(Comment::class, 'commentable');
    }

    # laravel scout
    public function toSearchableArray()
    {
        $array = $this->toArray();

        return $array;
    }

}

app/Http/Controllers/ArticleController.php
<?php

namespace App\Http\Controllers;

use App\Enums\ArticleStatus;
use App\Http\Requests\ArticleRequest;
use App\Models\Article;
use App\Models\Category;
use App\Models\Comment;
use App\Models\Tag;
use App\Models\User;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;

class ArticleController extends Controller
{
    # method __construct for middleware, data categories, and data tags
    public function __construct()
    {
        $this->middleware(['auth', 'verified', 'can.write.article', 'preventBackHistory'])->except(['show', 'index', 'search']);
        $this->categories = Category::select('id', 'name')->get();
        $this->tags = Tag::select('id', 'name')->get();
    }

    # process search articles
    public function search(Request $request)
    {
        # validation
        $request->validate([
            'q' => ['required']
        ]);

        # action get articles buy title, user, category, and tags
        $articles = Article::query()->latest()->when(request()->q, function ($articles) {
            $articles->where('title', 'like', '%' . request()->q . '%')->where('status', ArticleStatus::PUBLISHED)
                ->orWhereHas('user', function (Builder $query) {
                    $query->where('name', 'like', '%' . request()->q . '%')->where('status', ArticleStatus::PUBLISHED);
                })
                ->orWhereHas('category', function (Builder $query) {
                    $query->where('name', 'like', '%' . request()->q . '%')->where('status', ArticleStatus::PUBLISHED);
                })
                ->orWhereHas('tags', function (Builder $query) {
                    $query->where('name', 'like', '%' . request()->q . '%')->where('status', ArticleStatus::PUBLISHED);
                });
        })->get();

        # return view
        return view('articles.search', compact('articles'));
    }

    # table of articles
    public function table(Request $request)
    {
        # table of articles
        $articles = Article::without(['category', 'tags'])
            ->when(!$request->user()->isAdmin(), fn ($query) => $query->whereBelongsTo($request->user()))
            ->latest()
            ->paginate(10);

        # return view
        return view('articles.table', compact('articles'));
    }

    # update status article (pending, rejected, published)
    public function updateStatus(Request $request, Article $article)
    {
        # action change status article
        $article->forceFill([
            'status' => $request->status,
            'published_at' => now(),
        ])->save();

        # redirect
        return back();
    }

    # show all articles
    public function index()
    {
        # action get all data articles
        $articles = Article::query()->where('status', ArticleStatus::PUBLISHED)->latest()->paginate(15);

        # return view
        return view('articles.index', compact('articles'));
    }

    # view edit article
    public function create()
    {
        # get data categories, tags, and article
        $categories = $this->categories;
        $tags = $this->tags;
        $article = new Article();

        # return view
        return view('articles.create', compact('categories', 'tags', 'article'));
    }

    # process create article
    public function store(ArticleRequest $request)
    {
        # action create article
        $fileRequest = $request->file('picture');
        $article = Auth::user()->articles()->create([
            'title' => $title = $request->title,
            'slug' => $slug = str($title . ' ' . str()->random(3))->slug(),
            'body' => $request->body,
            'category_id' => $request->category,
            'picture' => $request->hasFile('picture')
                ? $fileRequest->storeAs('articles/images', $slug . '.' . $fileRequest->extension()) : null,
        ]);
        # create tags handle in article
        $article->tags()->attach($request->tags);

        # redirect
        return to_route('articles.show', $article)->with('success', 'Data article has been created ');
    }

    # show article spesific
    public function show(Article $article)
    {
        // $relatedArticles = Article::query()->where('category_id', $article->category_id)->where('id', '!=', $article->id)
        // ->latest()->limit(9)->get();

        # related articles
        $relatedArticles = Article::query()
            ->whereBelongsTo($article->category)
            ->published()
            ->whereNot('id', $article->id)
            ->latest()
            ->limit(9)
            ->get();

        # comments user in spesific article
        $comments = Comment::query()->select('user_id', 'body', 'created_at', 'id')->with('user')
            ->withCount('likes')->whereMorphedTo('commentable', $article)->get();

        # policy
        $this->authorize('viewIfOnlyAuthorOrAdmin', $article);

        # get count likes article spesific
        $article = $article->loadCount('likes');

        # return view
        return view('articles.show', compact('relatedArticles', 'comments', 'article'));
    }

    # view edit article
    public function edit(Article $article)
    {
        # policy
        $this->authorize('view', $article);

        # get data categories and tags
        $categories = $this->categories;
        $tags = $this->tags;

        # return view
        return view('articles.edit', compact('article', 'categories', 'tags'));
    }

    # process update article
    public function update(ArticleRequest $request, Article $article)
    {
        # policy
        $this->authorize('update', $article);

        # picture article handle
        $title = $request->title;
        $slug = str($title . ' ' . str()->random(5))->slug();
        $fileRequest = $request->file('picture');

        if ($request->hasFile('picture')) {
            if ($article->picture) {
                Storage::delete($article->picture);
            }
            $picture = $fileRequest->storeAs('articles/images', $slug . '.' . $fileRequest->extension());
        } else {
            $picture = $article->picture;
        }

        # action edit article
        $article->update([
            'title' => $title,
            'slug' => $slug,
            'body' => $request->body,
            'category_id' => $request->category,
            'picture' => $picture,
        ]);

        # update tag handle
        $article->tags()->sync($request->tags, true);

        # redirect
        return redirect()->route('articles.show', $article)->with('success', 'Data article has been updated ');
    }

    # process delete article
    public function destroy(Article $article)
    {
        # policy
        $this->authorize('delete', $article);

        # delete picture article in storage
        if ($article->picture) {
            Storage::delete($article->picture);
        }

        # detach tags (delete tags in pivot table)
        $article->tags()->detach();

        # action delete article
        $article->delete();

        # redirect
        return redirect()->route('articles.index')->with('success', 'Data article has been deleted ');
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use App\Enums\ArticleStatus;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\View\Component;

class AppLayout extends Component
{
    public $title;
    /**
     * Create a new component instance.
     *
     * @return void
     */

    public function __construct($title = 'Default Title')
    {
        $this->title = $title;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $categories = \App\Models\Category::query()
        ->select('name', 'slug')
        ->whereHas('articles', function(Builder $query) {
            $query->where('status', ArticleStatus::PUBLISHED);
        })
        ->get();
        return view('layouts.app', compact('categories'));
    }
}

app/View/Components/Article.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class Article extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public $article;
    public function __construct($article)
    {
        $this->article = $article;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        return view('components.article');
    }
}

app/View/Components/Articles/Index.php
<?php

namespace App\View\Components\Articles;

use Illuminate\View\Component;

class Index extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct(public $articles)
    {
        $this->articles = $articles;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        return view('components.articles.index');
    }
}

app/View/Components/Articles/Single.php
<?php

namespace App\View\Components\Articles;

use Illuminate\View\Component;

class Single extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct(public $article)
    {
        $this->article = $article;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        return view('components.articles.single');
    }
}

resources/views/articles/create.blade.php
<x-app-layout title="New article - GreenK Article">
  <div class="container">
    <x-card class="mb-4" title="New" subtitle="Create new article" class="shadow">
      {{-- form create article --}}
      <form action="{{ route('articles.store') }}" method="POST" enctype="multipart/form-data">
        @include('articles.form', ['submit' => 'Create'])
      </form>
    </x-card>
  </div>
</x-app-layout>

resources/views/articles/edit.blade.php
<x-app-layout title="Edit Article {{ $article->title }} - GreenK Article">
  <div class="container">
    <x-card title="mb-4" title="Edit Article" subtitle="{{ $article->title }}" class="shadow">
      {{-- form edit article --}}
      <form action="{{ route('articles.update', $article) }}" method="POST" enctype="multipart/form-data">
        @method('PUT')
        @include('articles.form', ['submit' => 'Update'])
      </form>
    </x-card>

    {{-- delete button modal --}}
    <div class="text-end mt-2">
      <button type="button" class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#exampleModal">
        Delete
      </button>
    </div>
    <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
          <div class="modal-header">
            <div class="modal-title" id="exampleModalLabel">{{ $article->title }}</div>
            <button type="button" class="btn-close" data-bs-dismiss="modal" arialabel="Close"></button>
          </div>
          <div class="modal-body">
            <p class="text-muted text-center">Are you really sure you want to delete
              it?</p>
            <div class="d-flex align-items-center gap-2 justify-content-center">
              <form action="{{ route('articles.destroy', $article) }}" method="POST">
                @csrf
                @method('DELETE')
                <button type="submit" class="btn btn-danger">
                  Yes
                </button>
              </form>
              <button type="button" class="btn btn-secondary" data-bs-dismiss="modal" aria-label="Close">No</button>
            </div>
          </div>
        </div>
      </div>
    </div>

  </div>
  <br>
</x-app-layout>

resources/views/articles/form.blade.php
@push('styles')
{{-- select2 --}}
<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/select2-bootstrap-5-theme@1.3.0/dist/select2-bootstrap-5-theme.min.css" />
{{-- ckeditor 4 --}}
<link rel="stylesheet" href="{{ asset('assets/css/articles/ckeditor.css') }}">
@endpush

{{-- form --}}
@csrf
<div class="row">
  <div class="col-md-4">
    {{-- title --}}
    <div class="mb-2">
      <label for="title" class="form-label">Title</label>
      <input type="text" name="title" id="title" value="{{ old('title', $article->title) }}" class="form-control @error('title') is-invalid @enderror" placeholder="Title">
      @error('title')
      <div class="invalid-feedback">{{ $message }}</div>
      @enderror
    </div>
    
    {{-- picture --}}
    <div class="mb-2">
      <label for="picture" class="form-label">Picture</label>
      <input type="file" name="picture" id="picture" class="form-control @error('picture') is-invalid @enderror">
      @error('picture')
      <div class="invalid-feedback">{{ $message }}</div>
      @enderror
    </div>

    {{-- category --}}
    <div class="mb-2">
      <label for="category" class="form-label">Category</label>
      <select name="category" id="category" class="form-control @error('category') is-invalid @enderror">
        <option selected disabled>Choose category</option>
        @foreach ($categories as $category)
        <option {{ old('category')==$category->id || $article?->category_id == $category->id ? 'selected' : ''}} value="{{ $category->id }}">
          {{ $category->name }}
        </option>
        @endforeach
      </select>
      @error('category')
      <div class="invalid-feedback">{{ $message }}</div>
      @enderror
    </div>

    {{-- tags --}}
    <div class="mb-2">
      <label for="tags" class="form-label">Tags</label>
      <select name="tags[]" id="tags" class="form-control @error('tags') is-invalid @enderror" multiple>
        @foreach ($tags as $tag)
        <option {{ ($article?->tags()->find($tag->id)) || (collect(old('tags'))->contains($tag->id)) ?
                    'selected' : '' }} value="{{ $tag->id }}">{{ $tag->name }}</option>
        @endforeach
      </select>
      @error('tags')
      <div class="invalid-feedback">{{ $message }}</div>
      @enderror
    </div>
  </div>

  <div class="col-md-8">
    {{-- body --}}
    <div class="mb-2">
      <label for="body" class="form-label">Body</label>
      <textarea name="body" id="body" class="form-control @error('body') is-invalid @enderror">{{ old('body', $article->body) }}</textarea>
      @error('body')
      <div class="invalid-feedback">{{ $message }}</div>
      @enderror
    </div>
  </div>
</div>

{{-- button submit --}}
<div class="text-end">
  <button type="submit" class="btn btn-primary btn-md">{{ $submit }}</button>
</div>

@push('scripts')
{{-- select2 --}}
<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.0/dist/jquery.slim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
<script>
  $('#tags,#category').select2({
    theme: 'bootstrap-5'
  });

</script>
{{-- ck editor 4 --}}
<script src="{{ asset('assets/js/ckeditor/ckeditor.js') }}"></script>
<script>
  CKEDITOR.replace('body', {
    language: 'en'
    , height: 400
  , });

</script>
@endpush

resources/views/articles/index.blade.php
<x-app-layout title="All Articles - GreenK Article">
  @push('styles')
  @include('components.toast.alerts-css')
  @endpush
  <x-header title="Articles">
    @slot('subtitle')
    Find your favorite article only here
    @endslot
  </x-header>
  <div class="container">
    <x-articles :articles="$articles" />
  </div>
  @push('scripts')
  @include('components.toast.alerts-js')
  @endpush
</x-app-layout>

resources/views/articles/search.blade.php
<x-app-layout title="All Articles - GreenK Article">
  <x-header title="Articles">
    @slot('subtitle')
    Your search results for <span class="fw-bold">"{{ request()->q }}"</span>
    @endslot
  </x-header>
  <div class="container">
    <x-articles :articles="$articles" />
  </div>
</x-app-layout>

resources/views/articles/show.blade.php
<x-app-layout title="{{ $article->title }} - GreenK Article">
    @push('styles')
    @include('components.toast.alerts-css')
    @endpush
  <div class="bg-skyline text-white mb-5 border-bottom py-5" style="margin-top: -24px">
    <div class="container">
      <div class="d-flex align-items-center gap-5 py-4 px-2">
        <div class="col-lg-7">
          <div class="me-auto">
            <div class="d-flex align-items-center gap-2 mb-3">
              {{-- category --}}
              <a href="{{ route('categories.show', $article->category) }}" class="btn btn-primary btn-sm">
                {{ $article->category->name }}
              </a>
              {{-- tags --}}
              @foreach ($article->tags as $tag)
              <a href="{{ route('tags.show', $tag) }}" class="btn btn-dark btn-sm">
                #{{ $tag->name }}
              </a>
              @endforeach
            </div>
            {{-- article title --}}
            <h1 class="display-6 fw-semibold mt-2">{{ $article->title }}</h1>
            <hr>

            {{-- article body (header) --}}
            <p class="text-align lead">{!! str($article->body)->limit(150) !!}</p>
            <div class="d-flex align-items-center justify-content-between mt-4">
              <div class="text-white-50">
                {{-- published / created_at and user--}}
                {{ $article->created_at->format('d F, Y') }} by
                {{-- user / writer --}}
                <a href="{{ route('users.show', $article->user) }}" class="text-white">
                  {{ $article->user->name }}
                </a>
                &middot;
                {{-- likes count --}}
                <span>
                  {{ $article->likes_count }} {{ str('like')->plural($article->likes_count) }}
                </span>
              </div>
              <div class="d-flex align-items-center gap-2">

                {{-- button article like --}}
                @auth
                <form action="{{ route('articles.like', $article) }}" method="POST">
                  @csrf
                  <a href="{{ route('articles.like', $article) }}"
                  class="btn btn-sm btn-light" onclick="event.preventDefault();this.closest('form').submit()">
                    {{ $article->alreadyLiked() ? 'Unlike' : 'Like' }}
                  </a>
                </form>
                @endauth

                {{-- button edit article --}}
                @can('update', $article)
                <a href="{{ route('articles.edit', $article) }}" class="btn btn-light btn-sm">
                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-pencil" viewBox="0 0 16 16">
                    <path d="M12.146.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1 0 .708l-10 10a.5.5 0 0 1-.168.11l-5 2a.5.5 0 0 1-.65-.65l2-5a.5.5 0 0 1 .11-.168l10-10zM11.207 2.5 13.5 4.793 14.793 3.5 12.5 1.207 11.207 2.5zm1.586 3L10.5 3.207 4 9.707V10h.5a.5.5 0 0 1 .5.5v.5h.5a.5.5 0 0 1 .5.5v.5h.293l6.5-6.5zm-9.761 5.175-.106.106-1.528 3.821 3.821-1.528.106-.106A.5.5 0 0 1 5 12.5V12h-.5a.5.5 0 0 1-.5-.5V11h-.5a.5.5 0 0 1-.468-.325z" />
                  </svg>
                </a>
                @endcan
              </div>
            </div>

          </div>
        </div>

        {{-- picture article --}}
        <div class="col-lg-5" id="image-article">
          <img src="{{ (substr($article->picture, 0, 5) == 'https') ? $article->picture : asset('storage/' . $article->picture ) }}" alt="" class="w-80 rounded ms-2 img-fluid d-none d-lg-block" style="max-height: 225px; width:400px">
        </div>

      </div>
    </div>
  </div>

  <div class="container">
    <div class="row">
      <div class="col-md-8">

        {{-- article body --}}
        <div class="article-body">
          {!! str($article->body)->markdown() !!}
        </div>

        {{-- comments --}}
        <x-articles.comment.block :comments="$comments" />
        <x-articles.comment.form :article="$article" :action="route('comments.store', $article)" method="POST" />
      </div>

      {{-- related articles --}}
      @if (count($relatedArticles) > 0)
      <div class="col-md-4 text-center">
        <h4 class="fw-bolder border-bottom border-4">Related Articles</h4>

        <ul class="list-group list-group-flush">
          @foreach($relatedArticles->shuffle() as $article)
          <li class="list-group-item">
            <a href="{{ route('articles.show', $article) }}" class="text-decoration-none">
              {{ $article->title }}
            </a>
          </li>
          @endforeach
        </ul>
      </div>
      @endif

    </div>
  </div>
  @push('scripts')
  @include('components.toast.alerts-js')
  @endpush
</x-app-layout>

resources/views/articles/table.blade.php
<x-app-layout title="Table of Articles - GreenK Article">
  <div class="container">
    <x-card title="Table of Articles"
    subtitle="Hello {{ auth()->user()->name }}, you can approve or reject articles to be published" class="shadow">

      <div class="table-responsive">
        <table class="table table-striped">
          <thead>
            <th>#</th>
            <th>Title</th>
            <th>Status</th>
            <th>Author</th>
            <th>Created at</th>
            <th></th>
          </thead>

          <tbody>
            @foreach ($articles as $article)
            <tr>
              <td>{{ $articles->firstItem() + $loop->index }}</td>
              <td>
                <a href="{{ route('articles.show', $article) }}" class="text-decoration-none">
                  {{ $article->title }}
                </a>
              </td>
              {{-- article status --}}
              <td>
                @if ($article->status->name == 'PUBLISHED')
                <span class="badge bg-success">
                  {{ $article->status->name }}
                </span>
                @elseif ($article->status->name == 'PENDING')
                <span class="badge bg-warning">
                  {{ $article->status->name }}
                </span>
                @else
                <span class="badge bg-danger">
                  {{ $article->status->name }}
                </span>
                @endif
              </td>
              <td>{{ $article->user->name }}</td>
              <td>{{ $article->created_at->format('d F, Y') }}</td>
              @hasRole('admin')
              <td>
                <x-table.dropdown-menu :article="$article">
                  @if($article->status == \App\Enums\ArticleStatus::PENDING)
                  <li>
                    {{-- APPROVE --}}
                    <form action="{{ route('articles.update-status', $article) }}" method="POST">
                      @csrf @method('PUT')
                      <input type="hidden" name="status" value="{{ \App\Enums\ArticleStatus::PUBLISHED->value }}">
                      <a href="{{ route('articles.update-status', $article) }}" class="dropdown-item" onclick="event.preventDefault();
                                                    this.closest('form').submit()"> Approve
                      </a>
                    </form>
                  </li>
                  {{-- REJECTED --}}
                  <li>
                    <form action="{{ route('articles.update-status', $article) }}" method="POST">
                      @csrf @method('PUT')
                      <input type="hidden" name="status" value="{{ \App\Enums\ArticleStatus::REJECTED->value }}">
                      <a href="{{ route('articles.update-status', $article) }}" class="dropdown-item" onclick="event.preventDefault();
                                                    this.closest('form').submit()"> Rejected
                      </a>
                    </form>
                  </li>
                  @endif
                  {{-- PENDING --}}
                  @if($article->status == \App\Enums\ArticleStatus::REJECTED)
                  <li>
                    <form action="{{ route('articles.update-status', $article) }}" method="POST">
                      @csrf @method('PUT')
                      <input type="hidden" name="status" value="{{ \App\Enums\ArticleStatus::PENDING->value }}">
                      <a href="{{ route('articles.update-status', $article) }}" class="dropdown-item" onclick="event.preventDefault();
                                                    this.closest('form').submit()"> Pending
                      </a>
                    </form>
                  </li>
                  {{-- TAKEDOWN --}}
                  <li>
                    <form action="{{ route('articles.update-status', $article) }}" method="POST">
                      @csrf @method('PUT')
                      <input type="hidden" name="status" value="{{ \App\Enums\ArticleStatus::TAKEDOWN->value }}">
                      <a href="{{ route('articles.update-status', $article) }}" class="dropdown-item" onclick="event.preventDefault();
                                                    this.closest('form').submit()"> Takedown
                      </a>
                    </form>
                  </li>
                  @endif
                  {{-- TAKE DOWN --}}
                  @if($article->status == \App\Enums\ArticleStatus::PUBLISHED )
                  <li>
                    <form action="{{ route('articles.update-status', $article) }}" method="POST">
                      @csrf @method('PUT')
                      <input type="hidden" name="status" value="{{ \App\Enums\ArticleStatus::TAKEDOWN->value }}">
                      <a href="{{ route('articles.update-status', $article) }}" class="dropdown-item" onclick="event.preventDefault();
                                                    this.closest('form').submit()"> Take Down
                      </a>
                    </form>
                  </li>
                  @endif
                </x-table.dropdown-menu>
              </td>
              @endHasRole
              @hasRole('writer')
              <td></td>
              @endHasRole
            </tr>
            @endforeach
          </tbody>
        </table>

      </div>
      {{-- pagination --}}
      {{ $articles->links() }}
    </x-card>
  </div>
</x-app-layout>